package cs108;

/**
 * Une image continue et infinie, représentée par une fonction associant une
 * couleur à chaque point du plan.
 */

public interface ImageRGB {
    public ColorRGB apply(float x, float y);

    public static final class RedDisk implements ImageRGB {
        @Override
        public ColorRGB apply(float x, float y) {
            double r = Math.sqrt(x * x + y * y);
            return r <= 1.0 ? ColorRGB.RED : ColorRGB.WHITE;
        }
    }

    public static final ImageRGB RED_DISK =
            new RedDisk();
}
